module trdefinitions
    type tracking_cloud
      integer np,ntracks
      real, dimension(:), pointer :: time
      real,dimension(:),pointer :: Mad_AHe_std, Mad_AHe_small, Mad_AHe_medium
      real,dimension(:),pointer :: Mad_AHe_large, Mad_AHe_lowdam, Mad_AHe_moddam
      real,dimension(:),pointer :: Mad_AHe_hidam, Mad_ZHe, Mad_ArKFs, Mad_ArBio
      real,dimension(:),pointer :: Mad_ArHorn, Mad_ArMusc, Mad_Ti_UTh_He
      real,dimension(:),pointer :: Mad_AFT
      real,dimension(:),pointer :: Mad_ZFT
      real,dimension(:),pointer :: Muscovite, ZFT, Apatite_U_Th_Pb, Biotite
      real,dimension(:),pointer :: Rutile_U_Pb, Titanite_U_Pb, Zircon_U_Pb    
      real, dimension(:,:),pointer :: x,y,z,press,temp,velo,veloZ
      integer,dimension(:),pointer :: step
      integer,dimension(:,:),pointer :: tracks
    end type tracking_cloud

    type input_parameters
        character(150) :: dir
        integer :: first
        integer :: last
        integer :: step
        integer :: nstep
    end type input_parameters

    type output_parameters
        character(150) :: dir
        integer :: mode
        integer :: scaled
        integer :: first
        integer :: last
        integer :: step
        integer :: nstep
        integer :: keep_nstep
        integer :: min_track
        real    :: pad_age
        integer :: Mad_AHe_std
        integer :: Mad_AHe_small
        integer :: Mad_AHe_medium
        integer :: Mad_AHe_large
        integer :: Mad_AHe_lowdam
        integer :: Mad_AHe_moddam
        integer :: Mad_AHe_hidam
        integer :: Mad_ZHe
        integer :: Mad_ArKFs
        integer :: Mad_ArBio
        integer :: Mad_ArHorn
        integer :: Mad_ArMusc
        integer :: Mad_Ti_UTh_He
        integer :: Mad_AFT
        integer :: Mad_AFT_param
        integer :: Mad_ZFT
        integer :: Mad_ZFT_param
        integer :: Muscovite
        integer :: ZFT
        integer :: Apatite_U_Th_Pb
        integer :: Biotite
        integer :: Rutile_U_Pb
        integer :: Titanite_U_Pb
        integer :: Zircon_U_Pb    
        integer :: ageID
        integer :: nages
        integer :: velo
        integer :: veloz
        integer :: temp
        integer :: press
        integer :: time
        integer :: istep
        integer :: trackID
        integer :: ntrackvars
    end type output_parameters

    interface correct_number
        subroutine correct_numberdp (x)
            real(8), intent(inout) :: x
        end subroutine correct_numberdp
        subroutine correct_numbersp (x)
            real, intent(inout) :: x
        end subroutine correct_numbersp
    end interface correct_number

end module trdefinitions

